#define RVATOVA(base,offset) ((PVOID)((DWORD)(base)+(DWORD)(offset)))
#define ibaseDD *(PDWORD)&ibase
#define STATUS_INFO_LENGTH_MISMATCH ((NTSTATUS)0xC0000004L)
#define NT_SUCCESS(Status) ((NTSTATUS)(Status) >= 0)
#define IOCTL_MAP 0x8234A208
#define IOCTL_UNHOOK 0x8234A20C

typedef struct {
    WORD    offset:12;
    WORD    type:4;
} IMAGE_FIXUP_ENTRY, *PIMAGE_FIXUP_ENTRY;

typedef LONG NTSTATUS;

typedef struct _SYSTEM_MODULE_INFORMATION {
    ULONG    Reserved[2];
    PVOID    Base;
    ULONG    Size;
    ULONG    Flags;
    USHORT   Index;
    USHORT   Unknown;
    USHORT   LoadCount;
    USHORT   ModuleNameOffset;
    CHAR     ImageName[256];
} SYSTEM_MODULE_INFORMATION, *PSYSTEM_MODULE_INFORMATION;

typedef struct {
    DWORD    dwNumberOfModules;
    SYSTEM_MODULE_INFORMATION    smi;
} MODULES, *PMODULES;

typedef struct UnHookEntry {
	unsigned int index;
	PVOID address;
} UHE;

#define SystemModuleInformation 11

DWORD GetHeaders(PCHAR ibase,
                PIMAGE_FILE_HEADER *pfh,
                PIMAGE_OPTIONAL_HEADER *poh,
                PIMAGE_SECTION_HEADER *psh)

{
    PIMAGE_DOS_HEADER mzhead = (PIMAGE_DOS_HEADER)ibase;
    
    if ((mzhead->e_magic!=IMAGE_DOS_SIGNATURE) || (ibaseDD[mzhead->e_lfanew]!=IMAGE_NT_SIGNATURE))
		return FALSE;
    
    *pfh = (PIMAGE_FILE_HEADER)&ibase[mzhead->e_lfanew];
    if (((PIMAGE_NT_HEADERS)*pfh)->Signature!=IMAGE_NT_SIGNATURE) 
        return FALSE;

    *pfh = (PIMAGE_FILE_HEADER)((PBYTE)*pfh+sizeof(IMAGE_NT_SIGNATURE));
    
    *poh = (PIMAGE_OPTIONAL_HEADER)((PBYTE)*pfh+sizeof(IMAGE_FILE_HEADER));
    if ((*poh)->Magic!=IMAGE_NT_OPTIONAL_HDR32_MAGIC)
        return FALSE;
    
    *psh = (PIMAGE_SECTION_HEADER)((PBYTE)*poh+sizeof(IMAGE_OPTIONAL_HEADER));
    return TRUE;
}


DWORD FindKiServiceTable(HMODULE hModule, DWORD dwKSDT)
{
    PIMAGE_FILE_HEADER     pfh;
    PIMAGE_OPTIONAL_HEADER poh;
    PIMAGE_SECTION_HEADER  psh;
    PIMAGE_BASE_RELOCATION pbr;
    PIMAGE_FIXUP_ENTRY     pfe;    
    
    DWORD dwFixups = 0, i, dwPointerRva, dwPointsToRva, dwKiServiceTable;
    BOOL  bFirstChunk;

    GetHeaders((PCHAR)hModule, &pfh, &poh, &psh);

    // Cerca nella lista dei reloc per trovare la mov di inizializzazione
    if ((poh->DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress) &&
        (!((pfh->Characteristics)&IMAGE_FILE_RELOCS_STRIPPED))) {
        
        pbr = (PIMAGE_BASE_RELOCATION)RVATOVA(poh->DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress,hModule);

        bFirstChunk = TRUE;
        while (bFirstChunk || pbr->VirtualAddress) {
            bFirstChunk = FALSE;
            pfe=(PIMAGE_FIXUP_ENTRY)((DWORD)pbr+sizeof(IMAGE_BASE_RELOCATION));

            for (i=0;i<(pbr->SizeOfBlock-sizeof(IMAGE_BASE_RELOCATION))>>1;i++,pfe++) {
                if (pfe->type==IMAGE_REL_BASED_HIGHLOW) {
                    dwFixups++;
                    dwPointerRva=pbr->VirtualAddress+pfe->offset;
                    dwPointsToRva=*(PDWORD)((DWORD)hModule+dwPointerRva)-(DWORD)poh->ImageBase;

                    if (dwPointsToRva==dwKSDT) {
                        if (*(PWORD)((DWORD)hModule+dwPointerRva-2)==0x05c7) {
                            dwKiServiceTable=*(PDWORD)((DWORD)hModule+dwPointerRva+4)-poh->ImageBase;
                            return dwKiServiceTable;
                        }
                    }                  
                } 
            }
            *(PDWORD)&pbr += pbr->SizeOfBlock;
        }
    }    
    return 0;
}


BOOL doUnhook()
{    
    HMODULE  hKernel;
    DWORD    dwKSDT;              
    DWORD    dwKiServiceTable;    
    PMODULES pModules=(PMODULES)&pModules;
    DWORD    dwNeededSize,rc;
    DWORD    dwKernelBase,dwServices=0;
    PCHAR    pKernelName;
    PDWORD   pService;
	HMODULE	 hntdll;
	DWORD    dummy;
	HANDLE   hdev;
	UHE      drv_struct;
    PIMAGE_FILE_HEADER     pfh;
    PIMAGE_OPTIONAL_HEADER poh;
    PIMAGE_SECTION_HEADER  psh;
	NTSTATUS (WINAPI * _NtQuerySystemInformation)(UINT, PVOID, ULONG, PULONG);

	hntdll = GetModuleHandle("ntdll.dll");
	*(FARPROC *)&_NtQuerySystemInformation = GetProcAddress(hntdll, "ZwQuerySystemInformation");
	if (!_NtQuerySystemInformation) 
		return FALSE;

    // Prende le informazioni su ntoskrnl dalla lista dei moduli (e' sempre il primo)
    rc = _NtQuerySystemInformation(SystemModuleInformation,pModules,4,&dwNeededSize);
    if (rc == STATUS_INFO_LENGTH_MISMATCH) {
        pModules = (PMODULES)GlobalAlloc(GPTR,dwNeededSize);
        rc = _NtQuerySystemInformation(SystemModuleInformation,pModules,dwNeededSize,NULL);
    }   
    if (!NT_SUCCESS(rc))
		return FALSE;
    
    dwKernelBase = (DWORD)pModules->smi.Base;
    pKernelName = pModules->smi.ModuleNameOffset+pModules->smi.ImageName;
   
    // Carica ntoskrnl come dll
	if ( !(hKernel = LoadLibraryEx(pKernelName,0,DONT_RESOLVE_DLL_REFERENCES)) )  {
		GlobalFree(pModules);
        return FALSE;        
	}

	GlobalFree(pModules);

	if (!(dwKSDT = (DWORD)GetProcAddress(hKernel,"KeServiceDescriptorTable"))) {
	    FreeLibrary(hKernel);
        return FALSE;
	}
 
    // Prende l'RVA di KeServiceDescriptorTable...
    dwKSDT -= (DWORD)hKernel;    
    // ...e cerca l'indirizzo alla ServiceTable tramite le reloc
	if (!(dwKiServiceTable = FindKiServiceTable(hKernel,dwKSDT))) {
	    FreeLibrary(hKernel);
        return FALSE;
	}

	// Apre il device di unhooking
	hdev = CreateFile("\\\\.\\MSH4DEV1", GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hdev == INVALID_HANDLE_VALUE) {
	    FreeLibrary(hKernel);
        return FALSE;
	}

	// Legge la preferred base del kernel
	GetHeaders((PCHAR)hKernel, &pfh, &poh, &psh);

	// Fa mappare al driver la sdt
	DeviceIoControl(hdev, IOCTL_MAP, NULL, 0, NULL, 0, &dummy, NULL);

	// Cicla le entry delle funzioni (XXX assumendo che dopo ci sia
	// un qualcosa che lo fa andare fuori dall'immagine del kernel)
	for (pService = (PDWORD)((DWORD)hKernel + dwKiServiceTable);
         *pService - poh->ImageBase < poh->SizeOfImage;
		 pService++, dwServices++) {
		drv_struct.address = (PVOID)((*pService) - poh->ImageBase + dwKernelBase);
		drv_struct.index = dwServices;
		DeviceIoControl(hdev, IOCTL_UNHOOK, &drv_struct, sizeof(drv_struct), NULL, 0, &dummy, NULL);
	}

	CloseHandle(hdev);
    FreeLibrary(hKernel);
	return TRUE;
}
